#include <bits/stdc++.h>

const int ps = 14;
const long long primes[] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43};
//const long long maxn = 1000000000000000LL;
const long long maxn = 931170240LL - 1;
int powers[ps];
long long max_ans = 0;
long long max_num = -1;
int best_powers[ps];

void go(int pos, long long num) {
    if (pos == ps) {
        if (num <= maxn) {
            long long ans = 1;
            for (int i = 0; i < ps; i++)
                ans *= (powers[i] + 1);
            if (ans > max_ans) 
            {
                max_ans = ans, max_num = num;
                for (int i = 0; i < ps; i++)
                    best_powers[i] = powers[i];
            }
        }
        return;
    }
    go(pos + 1, num);
    int lp = powers[pos];
    for (int power = 1; power <= 100; power++) {
        if (num * primes[pos] <= maxn) {
            num *= primes[pos];
            ++powers[pos];
            go(pos + 1, num);
        }
    }
    powers[pos] = lp;
}

int main() {
    go(0, 1LL);
    printf("%lld %lld\n", max_ans, max_num);
    for (int i = 0; i < ps; i++)
        printf("%lld - %d\n", primes[i], best_powers[i]);
}