#include <bits/stdc++.h>

using namespace std;

vector <long long> leftD, rightD;

void precalcDivisors(long long x, vector <long long> &ds) {
    for (long long i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            ds.push_back(i);
            if (i * i != x)
                ds.push_back(x / i);
        }
    }
    if (x > 1)
        ds.push_back(x);
    sort(ds.begin(), ds.end());
}

const int maxD = 2000;

int getLeft[maxD][maxD];
int getRight[maxD][maxD];
bool was[maxD][maxD];
bool dp[maxD][maxD];

bool go(int aPos, int bPos) {
    if (aPos == -1 || bPos == -1) {
        return (aPos == -1 && bPos == -1) ? false : true;
    }
    if (was[aPos][bPos])
        return dp[aPos][bPos];
    was[aPos][bPos] = true;
    for (int i = aPos; i >= 0; i--) {
        if (leftD[aPos] % leftD[i] == 0 && !go(getLeft[aPos][i], bPos))
            return dp[aPos][bPos] = true;
        if (leftD[aPos] % leftD[i] == 0 && rightD[bPos] % leftD[i] == 0 && !go(getLeft[aPos][i], getRight[bPos][i]))
            return dp[aPos][bPos] = true;
    }                                                                               
    for (int i = bPos; i >= 0; i--) {
        if (rightD[bPos] % rightD[i] == 0 && !go(aPos, getRight[bPos][i]))
            return dp[aPos][bPos] = true;
    }
    return dp[aPos][bPos] = false;
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    long long a, b;
    cin >> a >> b;
    if (a == 1 || b == 1) {
        printf("%s\n", (a == 1 && b == 1) ? "Alf wins" : "Lucky wins");
        return 0;
    }

    precalcDivisors(a, leftD);
    precalcDivisors(b, rightD);
    for (size_t i = 0; i < leftD.size(); i++) {
        for (size_t j = 0; j < leftD.size(); j++) {
            getLeft[i][j] = -1;
            if (leftD[i] % leftD[j] == 0 && i != j)
                getLeft[i][j] = lower_bound(leftD.begin(), leftD.end(), leftD[i] / leftD[j]) - leftD.begin();
        }
    }
    for (size_t i = 0; i < rightD.size(); i++) {
        for (size_t j = 0; j < rightD.size(); j++) {
            getRight[i][j] = -1;
            if (rightD[i] % rightD[j] == 0 && i != j) 
                getRight[i][j] = lower_bound(rightD.begin(), rightD.end(), rightD[i] / rightD[j]) - rightD.begin();
        }
    }
    cerr << "Done\n";

    if (!go((int)leftD.size() - 1, (int)rightD.size() - 1))
        cout << "Alf wins\n";
    else
        cout << "Lucky wins\n";
}