import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber;
    static void printTest(int[][] mtr) throws IOException {
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        tNumber++;
        out.println(mtr.length - 1);             
        for (int i = 1; i <= mtr.length - 1; i++) {
        	for (int j = 1; j <= mtr.length - 1; j++) {
        		out.print(mtr[i][j]);
        		if (j != mtr.length - 1)
        			out.print(" ");
        	}
        	out.println();
        }                
        out.close();
    }
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../tests/01");
        out.println("5");
		out.println("0 16 12 1 12"); 
		out.println("16 0 12 13 -1"); 
		out.println("12 12 0 5 2");
		out.println("1 13 5 0 2");
		out.println("12 -1 2 2 0");                
        out.close();
    }
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }
    static void makeRandomTest(int n, int maxD, int randConst) throws IOException {
    	int[][] mtr = new int[n + 1][n + 1];
    	for (int i = 1; i <= n; ++i) {
    		for (int j = i + 1; j <= n; ++j) {
    			int w;
    			if (randFromTo(0, randConst) == 0)
    				w = -1;
    			else
    				w = randFromTo(1, maxD);
    			mtr[i][j] = w;
    			mtr[j][i] = w;
    		}
    	}    	
    	printTest(mtr);
    }

    public static void main(String[] args) throws IOException {
        genSample();
        tNumber = 2;
    	printTest(new int[][]{{0, 0}, {0, 0}});    
    	for (int i = 0; i < 10; i++)
    		makeRandomTest(10, i + 1, 10);
		makeRandomTest(50, 10, 0);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(50, i + 1, 10);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(50, 1000, 10);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(50, 100000, 20);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(100, 10, 10);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(100, 3, 20);
		for (int i = 0; i < 5; i++)
    		makeRandomTest(200, 10, 20);
		for (int i = 0; i < 10; i++)
    		makeRandomTest(200, 100000, 10);        
		for (int i = 0; i < 5; i++)
    		makeRandomTest(300, 10, 20);
		for (int i = 0; i < 10; i++)
    		makeRandomTest(300, 100000, 10);        
    }
}
